/* "eqcs_gate.h"
 * Copyright (C) 1999 Peter Belkner <pbelkner@berlin.snafu.de>
 *
 * This file is part of the eqcs library. This library is free
 * software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License as published by the Free Software
 * Foundation; either version 2, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; see the file COPYING.  If not, write to the
 * Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */
#ifndef	_EQCS_GATE_H_
#ifdef __GNUG__
#pragma interface
#endif
#define	_EQCS_GATE_H_

#include <iostream>
#include "eqcs_state.h"

using namespace std;
class EqcsGateRep;

/*****************************************************************************\
*	gate																	  *
\*****************************************************************************/

class EqcsGate: public EqcsHandle {
public:
	typedef EqcsHandle base_t;
	typedef EqcsGateRep rep_t;
	typedef EqcsState::bitset_t bitset_t;
	typedef complex<double> complex_t;

	EqcsGate(rep_t *rep=0);

	void set(int i, int bit) const;
	EqcsState operator()(const EqcsState &state) const;

	// Some technical uitilities.
	inline rep_t *operator->() const
		{ return (rep_t *)EqcsHandle::rep(); }
	inline rep_t *rep() const
		{ return (rep_t *)EqcsHandle::rep(); }
};

ostream &operator<<(ostream &os, const EqcsGate &gate);

#endif	//	_EQCS_GATE_H_
