/* "eqcs_qc_rep.cc"
 * Copyright (C) 1999 Peter Belkner <pbelkner@berlin.snafu.de>
 *
 * This file is part of the eqcs library. This library is free
 * software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License as published by the Free Software
 * Foundation; either version 2, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; see the file COPYING.  If not, write to the
 * Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */
#ifdef __GNUG__
#pragma implementation
#endif

#include "eqcs_gate_array_rep.h"
#include "eqcs_gate_array.h"
#include "eqcs_qc_rep.h"

/*****************************************************************************\
*	quantum computer representation											  *
\*****************************************************************************/

EqcsQcRep::EqcsQcRep(const EqcsState &state) : _state(state)
	{}

EqcsQcRep::~EqcsQcRep()
	{}

void EqcsQcRep::prepare(const EqcsState &state)
	{ _state = state; }

EqcsState EqcsQcRep::observe(unsigned long bits)
	{ return _state = _state.collapse(bits); }

void EqcsQcRep::perform(const EqcsGate &gate)
	{ _state = gate(_state); }

void EqcsQcRep::perform(const EqcsGateArray &array)
{
	typedef EqcsGateArrayRep::const_iterator const_iterator;

	for (const_iterator p = array->begin(); p != array->end(); ++p)
		perform(*p);
}
